  // this is for the menu button operation at the right bottom corner on each page*/ 
    function menuOnClick() {
      document.getElementById("menu").classList.toggle("change");
      document.getElementById("menu-bar").classList.toggle("change");
      document.getElementById("navlist").classList.toggle("change");
      document.getElementById("menu-bg").classList.toggle("change-bg");
      document.getElementById("pop-logo").classList.toggle("change");
      // document.getElementById("nav-logo").classList.toggle("change-hide");
      var x = document.getElementById("nav-logo");
      if (x.style.display === "none") {
        x.style.display = "flex";
      } else {
        x.style.display = "none";
      }
    }
  
  // mapping for each notice type
  const noticeMappings = {
      examnotice : "2",
      examresults : "1",
      rescrutinyresults : "11",
      admission : "4",
      tendernotice : "7",
      othernotice : "6",
    };
  
  const noticeTitleMappings = {
      examnotice : "Examination Notices",
      examresults : "Examination Results",
      rescrutinyresults : "Rescrutiny Results",
      admission : "Admission Notices",
      tendernotice : "Tender Notices",
      othernotice : "Other Notices",
    };
  
  console.log("Inside noticelist page");
  var urlParams = new URLSearchParams(window.location.search);
  var searchKey = urlParams.get("id");
  console.log("searchKey in search results page: " + searchKey);
  
  
  // Fetch notices when the page loads
  fetchNotices();
  
  const noticesPerPage = 10;
  let currentPage = 0;
  let noticesData = []; // This will store all the notices from the JSON file
  let noticeFiltered = [];

  const noticeList = document.getElementById('notice-list');
  const listTitle = document.getElementById('nav-title');
  const loadMoreButton = document.getElementById('load-more');
  const loadPrevButton = document.getElementById('load-prev');

  const searchInput = document.getElementById('search-input');
  const searchButton = document.getElementById('btn-search');
  const homeButton = document.getElementById('load-home');
  
  var searchResultParagraph = document.getElementById("search-result");
  
  var snack = document.getElementById("snackbar");


  // Function to fetch notices from JSON file
//   async function fetchNotices() {
//     try {
//         console.log("inside fetch try");
//         const response = await fetch('json/noticelist.json');
//         noticesData = await response.json();
//         renderNotices();
//         } catch (error) {
//       console.error('Error fetching notices:', error);
//     }
//   }
  
  
//   async function fetchNotices() {
//     try {
//         console.log("inside fetch try");
//         const response = await fetch('json/notices.json');
//         const noticesData = await response.json();
    
//         // Filter noticesData based on the noticeMappings
//         const filteredNotices = noticesData.filter((notice) => {
//         const matchingCategory = Object.keys(noticeMappings).find(
//             (key) => noticeMappings[key] === notice.NewsCat
//         );
//         return !!matchingCategory; // Filter out notices without a matching category
//         });

//         renderNotices(filteredNotices);
//     } catch (error) {
//         console.error('Error fetching notices:', error);
//     }
//   }

  function fetchNotices() {
    function findMatchingEntries(data, category) {
        return data.filter((entry) => {
          const {NewsCat} = entry;
          const catMatch = NewsCat === noticeMappings[category];
          return catMatch;
        });
      }
  
    // Fetch the JSON data from a URL (replace with your JSON file URL)
    fetch('json/notices.json')
      .then((response) => response.json())
      .then((jsonData) => {
        // Find matching entries based on the input string
        console.log(jsonData);
        noticeFiltered = findMatchingEntries(jsonData, searchKey);
            //if (noticeFiltered === null || noticeFiltered.length === 0) {searchResultParagraph.textContent = "No Notice Found";}
        renderNotices(noticeFiltered);
      })
      .catch((error) => console.error('Error fetching JSON data:', error));
  }

  // Function to render notices based on the current page
  function renderNotices(notices) {
      
    // Remove previous notice items
    while (noticeList.firstChild) {
        noticeList.removeChild(noticeList.firstChild);
    }
    const startIndex = currentPage * noticesPerPage;
    const endIndex = startIndex + noticesPerPage;
    
    for (let i = startIndex; i < endIndex && i < notices.length; i++) { //noticesData
      const noticeItem = document.createElement('li');
      const noticeDate = document.createAttribute('notice-date');
      const noticeIndex = document.createAttribute('notice-index');
      //noticeDate.value = formatDate(notices[i].date); // Format date as DD-MMM
      noticeDate.value = notices[i].Month + " " +notices[i].Year;
      noticeIndex.value = notices[i].NewsId; 
      //noticeItem.textContent = notices[i].title;
      noticeItem.textContent = notices[i].NewsDesc;
      noticeItem.setAttributeNode(noticeDate);
      noticeItem.setAttributeNode(noticeIndex);
      console.log(notices[i].NewsCat);
      noticeList.appendChild(noticeItem);
    }
    
    listTitle.textContent = noticeTitleMappings[searchKey];

    loadMoreButton.disabled = endIndex >= noticesData.length;
    updateButtonVisibility();
    
    
    noticeList.addEventListener('click', (event) => {
      if (event.target.tagName === 'LI') {
        const selectedIndex = event.target.getAttribute('notice-index');
        const selectedData = selectedIndex;  //notices[selectedIndex]
    
        // Redirect to newpage.html with the selected data as a query parameter
        window.location.href = `noticeview.html?selectedData=${encodeURIComponent(JSON.stringify(selectedData))}`;
      }
    });

    
    
    
  } 

  // Function to format date as DD-MMM (e.g., 22 Aug)
  function formatDate(dateString) {
    const date = new Date(dateString);
    const options = { day: '2-digit', month: 'short' };
    return date.toLocaleDateString('en-US', options);
  }

  // Function to handle "Load More" button click
  function handleLoadMoreClick() {
    currentPage++;
    renderNotices();
    //alert('load more clicked');
  }
  loadMoreButton.addEventListener('click', handleLoadMoreClick);

  
  // Function to handle "Previous" button click
  function handleLoadPrevClick() {
    if (currentPage > 0) {
      currentPage--;
      renderNotices();
    }
  }
  loadPrevButton.addEventListener('click', handleLoadPrevClick);


  // Function to update button visibility based on current page
  function updateButtonVisibility() {
    loadPrevButton.style.display = currentPage === 0 ? 'none' : 'block';
    loadMoreButton.style.display = (currentPage + 1) * noticesPerPage >= noticesData.length ? 'none' : 'block';
  }
 

  // Function to search a pattern on key-up in the current list
  function searchNoticelist() {
    var filter, ul, li, a, i, txtValue;
    // input = document.getElementById("search-input");
    const searchText = searchInput.value;
    filter = searchText.toUpperCase();
    ul = document.getElementById("notice-list");
    li = ul.getElementsByTagName("li");
    for (i = 0; i < li.length; i++) {
        // a = li[i].getElementsByTagName("a")[0];
        txtValue = li[i].textContent || li[i].innerText;
        if (txtValue.toUpperCase().indexOf(filter) > -1) {
            li[i].style.display = "";
        } else {
            li[i].style.display = "none";
        }
    }
  }
  searchInput.addEventListener('keyup', searchNoticelist);
  
 // for searching on button click
  function searchNotices() {
      // Get the search key from the input field.
      var searchKey = searchInput.value;
      console.log("search button clicked");
      console.log("searched key is: " + searchKey);
      
      // Construct the URL for the new page with the searchKey as a query parameter
      var newPageURL = "searchnotices.html?searchKey=" + encodeURIComponent(searchKey);
      
      console.log(newPageURL);

      // Redirect to the new page
      window.location.href = newPageURL;

      console.log("new page, yay");
      alert("Fetching Search Results, Stay Tuned");
      
      
      // This trick didn't workout
      //snack.className = "show";
      // After 3 seconds, remove the show class from DIV
      //setTimeout(function(){ snack.className = snack.className.replace("show", ""); }, 3000);
      
  }
           
  // search notice and show in the same page, not in use
  function searchNotice2(){ 
        // JavaScript code to retrieve the searchKey from the query parameter
        var searchKey = searchInput.value;
        
        console.log("searchKey in search results page: " + searchKey);
      
        const searchResults = searchJSON(noticesData, searchKey);  //searchKey
        console.log("search reults at line 345: " + searchResults);
        //appendResultsToUI(searchResults);
      
      
      
        // Function to search for a term in the JSON data
        function searchJSON(jsonData, term) {
            const results = [];
            for (const item of jsonData) {
                // Iterate through the object's values and check if any contain the search term
                for (const value of Object.values(item)) {
                    if (typeof value === 'string' && value.toLowerCase().includes(term.toLowerCase())) {
                        results.push(item);
                        break; // Break out of the inner loop if a match is found
                    }
                }
            }
    
            console.log("Search results before return:", results);
            return results;
        }


        // Function to append search results to the unordered list
        function appendResultsToUI(results) {
            const searchResultsList = document.getElementById("notice-list");

            // Clear previous results
            searchResultsList.innerHTML = "";

            for (const result of results) {
                const noticeItem = document.createElement('li');
                const noticeLink = document.createElement('a');
                const noticeDate = document.createAttribute('notice-date');
                noticeDate.value = formatDate(result.date); // Format date as DD-MMM

                noticeLink.href = 'noticeview.html'; // Add your link here
                noticeLink.textContent = result.title;

                noticeItem.appendChild(noticeLink);
                noticeItem.setAttributeNode(noticeDate);

                searchResultsList.appendChild(noticeItem);
            }
        }
       alert("inside search notice func");
   }//end of search notice2
  
  
  
  // Function to handle search button click
  function handleSearchButtonClick() {
    console.log("inside handleSearchButtonClick(): ");
    searchNotices();
  }
  searchButton.addEventListener('click', handleSearchButtonClick);
    
  
  // Function to load home page on buttton click
  function handleHomeButtonClick() {
    window.location.href = "notice.html";
    //window.location.replace("index.html");
  }
  homeButton.addEventListener('click', handleHomeButtonClick);
  
  
  
  